/* This program uses call by reference
   to swap two numbers
*/

#include<stdio.h>

void swap(int *, int *); // notice how pointer type shown

int main() {

	int num1, num2;

	num1 = 111;
	num2 = 999;

	printf("--- Before Swap --- \n");
	printf("num1 = %d\n", num1);
	printf("num2 = %d\n\n", num2);

	swap(&num1, &num2); // call by reference

	printf("--- After Swap --- \n");
	printf("num1 = %d\n", num1);
	printf("num2 = %d\n", num2);
	
	return 0;
}

void swap(int *var1, int *var2){

	int temp;

	temp = *var1;
	*var1 = *var2; // indirect reference
	*var2 = temp;  // what if you use *var1?

}
